
#include "inkey.ch"
#include "setcurs.ch"
#include "getexit.ch"

Static  aAllCheck := {}


*--------------------------
* FUNCTION CHECKBOX
*--------------------------
* Waldo Gomez Alvarez

Function CheckBoxNew( oGet,           ; // objecto get
                     lEstado,         ; // .T. / .F.
                     cLabel,          ; // Etiqueta
                     lLeftLabel  )      // Etiqueta a la Izq.

Local cColor, nRow , nCol

nRow = oGet:Row
nCol = oGet:Col

lLeftLabel := If( lLeftLabel==NIL, .F. , lLeftLabel )
cColor     := oGet:ColorSpec

// Agrego al arreglo de CheckBox's.
aAdd( aAllCheck, { oGet:Name, cLabel, lLeftLabel } )

// Dibujo la CheckBox
DrawCheckBox( nRow, nCol, cLabel, lEstado, cColor, lLeftLabel )

Return NIL



Function DrawCheckBox( nRow, nCol, cLabel, lEstado , cColor , lLeftLabel )
*-------------------------------------------------------------------------

DispBegin()

If lLeftLabel

   If lEstado
      @ nRow, nCol Say cLabel + " [x]"   COLOR cColor
   Else
      @ nRow, nCol Say cLabel + " [ ]"   COLOR cColor
   Endif

Else

   If lEstado
      @ nRow, nCol Say "[x] " + cLabel  COLOR cColor
   Else
      @ nRow, nCol Say "[ ] " + cLabel  COLOR cColor
   Endif

Endif

If lLeftLabel
   SetPos( nRow, nCol + Len( cLabel ) + 2 )
Else
   SetPos( nRow, nCol + 1 )
Endif

DispEnd()

Return Nil


Function CheckReader( oGet )
*-----------------------------
Local nKey
Local lEstado
Local nCurs := SetCursor(0)
Local cLabel
Local cColor
Local lLeftLabel

lEstado    := oGet:VarGet()
cColor     := oGet:ColorSpec
cLabel     := aAllCheck[ Ascan( aAllCheck, { |a| a[1] == oGet:Name }),2]
lLeftLabel := aAllCheck[ Ascan( aAllCheck, { |a| a[1] == oGet:Name }),3]

DrawCheckBox( oGet:Row, oGet:Col, cLabel, lEstado, cColor, lLeftLabel )

oGet:exitState := GE_NOEXIT

Do While ( oGet:exitState == GE_NOEXIT )

    SetCursor(1)
    nKey := Inkey(0)
    SetCursor(0)

    DO CASE
    case nKey == K_ESC
        oGet:ExitState := GE_ESCAPE

    case nKey == K_ENTER .or. nKey == K_SPACE
        lEstado := !lEstado
        oGet:VarPut( lEstado )
        DrawCheckBox( oGet:Row, oGet:Col, cLabel, lEstado, cColor, lLeftLabel )

    case nKey == K_UP .or. nKey == K_LEFT .or. nKey == K_SH_TAB
        oGet:ExitState := GE_UP

    case nKey == K_DOWN .or. nKey == K_RIGHT .or. nKey == K_TAB
        oGet:ExitState := GE_DOWN

    ENDCASE

Enddo


Dispbegin()
cSavedScreen := savescreen( oGet:row, oGet:col, oGet:row, oGet:col )
oGet:KillFocus()
restscreen( oGet:row, oGet:col, oGet:row, oGet:col, cSavedScreen )
Dispend()

SetCursor( nCurs )

Return NIL


