
#include "inkey.ch"
#include "setcurs.ch"
#include "getexit.ch"


// Stack para botones
Static  aAllButtons := {}

#define B_LABEL      1
#define B_HOTKEY     2
#define B_POSHOTKEY  3

Function ReadControls( nPos )
*------------------------------
* Waldo Gomez Alvarez

ReadModal( GetList, nPos )
GetList := {}
aAllCheck := {}
aAllButtons := {}
aAllRadButtons := {}
Return NIL



/*
  FUNCTION PUSHNEW()
  -----------------
*/

Function PushNew( oGet,           ; // Objeto Get
                  nReturn,        ; // Valor a retornar
                  nChoice,        ; // Botn de comienzo
                  aChoices,       ; // Arreglo de botones usuario
                  cColores,       ; // Colores ( plop )
                  nGap,           ; // Separacin entre botones.
                  lHorizontal       ) // Opcin botones verticales

Local i
Local aButtons := {}                // { { cBotonLabel, cHotKey, nPosHotkey },....}
Local nTotButtons                   // N de botones.
Local cColStd, cColEnh              // Colores Standard, Enhanced botones.
Local cColStdHotKey, cColEnhHotKey  // id. para HotKey.
Local nRow, nCol

Local cBoton, cHotKey, nPosHotKey

Local nColFondo, cColShad

nRow = oGet:Row
nCol = oGet:Col

nColFondo := ASC( RIGHT( SAVESCREEN( nRow, nCol-1 , nRow, nCol-1 ) , 1 ) )
cColShad  := "N/"+ TOKEN( NTOCOLOR( nColFondo, .T. ) , "/" , 2 )

// Maneja defectos
nChoice      := If( Empty( nChoice ), 1 , nChoice )
aChoices     := If( Empty( aChoices ), { "Aceptar" }, aChoices )
lHorizontal  := If( Valtype(lHorizontal) == "L", lHorizontal, .F. )
cColores     := If( Valtype(cColores) == "C", cColores , Setcolor() )
nGap         := If( Valtype(nGap) == "N" , nGap , 1 )
nGap         := If( nGap > 0 , nGap  , 1 )

// Separo colores botones y HotKey ( Standard, Enhanced )
cColStd       := TOKEN( cColores , ",", 1 )
cColEnh       := TOKEN( cColores , ",", 2 )
cColStdHotKey := TOKEN( cColores , ",", 3 )
cColEnhHotKey := TOKEN( cColores , ",", 4 )

cColStdHotKey := If( EMPTY(cColStdHotKey), cColStd , cColStdHotKey )
cColEnhHotKey := If( EMPTY(cColEnhHotKey), cColEnh , cColEnhHotKey )

// nChoice est dentro del rango vlido ?.
nTotButtons := Len( aChoices )
If nChoice < 1 .or. nChoice >  nTotButtons
    nChoice := 1
Endif

// Preparo botones.
For i = 1 To nTotButtons

   cBoton := "  " + aChoices[i] + "  "

   If "&" $ cBoton
       nPosHotKey     := AT( "&", cBoton )
       cHotKey        := SUBSTR( cBoton, nPosHotKey+1 , 1 )
       cBoton         := CHARREM( "&", cBoton )
       AADD( aButtons, { cBoton ,cHotKey,  nPosHotKey-1  }  )
   Else
       AADD( aButtons , { cBoton, "" , 0 } )
   Endif

Next

// Agrego al arreglo de botones
aAdd( aAllButtons, { oGet:Name, aButtons, cColores, cColshad , lHorizontal, nGap  } )

// Dibuja los botones.
DrawButtons( nRow, nCol, aButtons, nChoice, lHorizontal, nGap, ;
                                   cColStd, cColEnh,;
                                   cColStdHotKey, cColEnhHotKey , cColShad )

Return NIL


/*
   FUNCTION DRAWBUTONS()
   ----------------------
*/

Function DrawButtons( nRow, nCol, aButtons, nChoice, lHorizontal, nGap, ;
                                            cColStd, cColEnh,;
                                            cColStdHotKey, cColEnhHotKey, cColShad ,;
                                            lFocus , lPressed )

Local i
Local nTotButtons
Local nBtnOffset   := 0
Local nOffSetPress := 0
Local nCurs := SETCURSOR(0)

lFocus   := If( Valtype(lFocus) == "L" , lFocus, .F. )
lPressed := If( Valtype(lPressed) == "L", lPressed , .F. )

nTotButtons := Len( aButtons )

DispBegin()

For i = 1 to nTotButtons

    DispBtn( nRow, nCol, nBtnOffset, aButtons[i], lHorizontal   ,;
                 cColStd, cColEnh                               ,;
                 cColStdHotKey, cColEnhHotKey, cColShad         ,;
                 If(nChoice==i .and. lFocus , .T. , .F. )       ,;
                 )

    If nChoice==i .and. lFocus
       nOffSetPress := nBtnOffSet
    Endif

    If lHorizontal
       nBtnOffset += ( Len( aButtons[i][B_LABEL] ) + nGap + 1 )
    Else
       nBtnOffset += ( nGap + 1 )
    Endif

Next

DispEnd()

If lPressed
    PushedBtn( nRow, nCol, nOffSetPress, lHorizontal   ,;
                 aButtons[nChoice]                     ,;
                 cColEnh, cColShad )
Endif

SETCURSOR( nCurs )

Return NIL


/*
   FUNCTION DISPBTN
   ----------------
*/

Function DispBtn( nRow, nCol, nBtnOffset, aButt, lHorizontal     ,;
                  cColStd, cColEnh                               ,;
                  cColStdHotKey, cColEnhHotKey, cColShad         ,;
                  lFocus                                          ;
                   )

Local cLabel, cHotKey, nPosHotKey


cLabel     := aButt[ B_LABEL ]
cHotKey    := aButt[ B_HOTKEY ]
nPosHotKey := aButt[ B_POSHOTKEY ]

If lFocus
   cLabel := CHR(16)+" "+SUBSTR(cLabel,3,Len(cLabel)-4)+" "+CHR(17)
Else
   cLabel := "  "+ SUBSTR(cLabel,3,Len(cLabel)-4) + "  "
Endif

If lHorizontal
   nCol := nCol + nBtnOffSet
Else
   nRow := nRow + nBtnOffSet
EndIf

If lFocus
   @ nRow,nCol SAY cLabel COLOR cColEnh
Else
   @ nRow,nCol SAY cLabel COLOR cColStd
Endif

// HotKey
If !EMPTY(cHotKey)
   If lFocus
      @ nRow, nCol + nPosHotKey Say cHotKey COLOR cColEnhHotKey
   Else
      @ nRow, nCol + nPosHotKey Say cHotKey COLOR cColStdHotKey
   Endif
Endif

// Sombra
@ nRow     , nCol+Len( cLabel )   Say Chr(220) COLOR cColShad
@ nRow + 1 , nCol+1               Say Repli( Chr(223), Len( cLabel ) ) COLOR cColShad

Return NIL


/*
   FUNCTION PUSHEDBTN()
   --------------------
   Simula botn presionado
*/
Function PushedBtn( nRow, nCol, nOffSetPress, lHorizontal   ,;
                    aButt                                   ,;
                    cColEnh, cColShad )

Local cScreenTmp
Local cLabel, cColFondo

cLabel    := aButt[ B_LABEL ]
cColFondo := "W/" + TOKEN( cColShad , "/" , 2 )

If lHorizontal
   nCol := nCol + nOffSetPress
Else
   nRow := nRow + nOffSetPress
EndIf

cScreenTmp := SaveScreen( nRow, nCol, nRow+1, nCol + Len( cLabel ) )
ClearWin( nRow, nCol, nRow+1, nCol + Len( cLabel ), cColFondo )

cLabel := CHR(16)+" "+SUBSTR(cLabel,3,Len(cLabel)-4)+" "+CHR(17)

@ nRow , nCol+1   Say cLabel COLOR cColEnh

MilliSec( 200 )

RestScreen( nRow, nCol, nRow+1, nCol+ Len(cLabel) , cScreenTmp )


Return NIL



/*
  FUNCTION PUSHREADER
  -------------------
  Controlador de los botones
*/

Function PushReader( oGet )

Local nCurs := SETCURSOR( 0 )
Local lHorizontal
Local cColores, cColStd, cColEnh, cColStdHotKey, cColEnhHotKey, cColShad
Local aButtons , nChoice, nMaxChoices
Local nOldChoice
LOCAL nKey
LOCAL aHotKeys := {}
LOCAL nGap

aButtons      := aAllButtons[ Ascan(aAllButtons, { |a| a[1] == oGet:Name }),2]
cColores      := aAllButtons[ Ascan(aAllButtons, { |a| a[1] == oGet:Name }),3]
cColShad      := aAllButtons[ Ascan(aAllButtons, { |a| a[1] == oGet:Name }),4]
lHorizontal   := aAllButtons[ Ascan(aAllButtons, { |a| a[1] == oGet:Name }),5]
nGap          := aAllButtons[ Ascan(aAllButtons, { |a| a[1] == oGet:Name }),6]

nChoice       := oGet:VarGet()
nMaxChoices   := Len( aButtons )

cColStd       := TOKEN( cColores , ",", 1 )
cColEnh       := TOKEN( cColores , ",", 2 )
cColStdHotKey := TOKEN( cColores , ",", 3 )
cColEnhHotKey := TOKEN( cColores , ",", 4 )

// Lleno arreglo de HotKeys
For i = 1 To nMaxChoices
   AADD( aHotKeys , aButtons[i,2] )
Next

// Aqu se pone el Get
Dispbegin()
cSavedScreen := savescreen( oGet:row, oGet:col, oGet:row, oGet:col )
oGet:SetFocus()
restscreen( oGet:row, oGet:col, oGet:row, oGet:col, cSavedScreen )
DispEnd()

DrawButtons( oGet:Row, oGet:Col, aButtons, nChoice, lHorizontal, nGap, ;
                   cColStd, cColEnh,;
                   cColStdHotKey, cColEnhHotKey, cColShad ,;
                   .T. )


oGet:exitState := GE_NOEXIT

Do WHILE ( oGet:exitState == GE_NOEXIT )

    nOldChoice := nChoice
    nKey := Inkey(0)

    DO CASE
    CASE nKey == K_ESC    ; oGet:ExitState := GE_ESCAPE
    CASE nKey == K_ENTER  ; oGet:ExitState := GE_ENTER
    CASE nKey == K_SPACE  ; oGet:ExitState := GE_ENTER

    CASE nKey == K_LEFT
         If lHorizontal
             nChoice := If(nChoice==1,nMaxChoices,nChoice-1)
         Else
             oGet:ExitState := GE_UP
         Endif

    CASE nKey == K_RIGHT
         If lHorizontal
             nChoice := If(nChoice==nMaxChoices,1,nChoice+1)
         Else
             oGet:ExitState := GE_DOWN
         Endif

    CASE nKey == K_UP
         If lHorizontal
             oGet:ExitState := GE_UP
         Else
             nChoice := If(nChoice==1,nMaxChoices,nChoice-1)
         Endif

    CASE nKey == K_DOWN
         If lHorizontal
             oGet:ExitState := GE_DOWN
         Else
             nChoice := If(nChoice==nMaxChoices,1, nChoice+1)
         Endif

    CASE nKey == K_TAB
         oGet:ExitState := GE_DOWN

    CASE nKey == K_SH_TAB
         oGet:ExitState := GE_UP

    OTHERWISE
         // Maneja pulsacin de una HotKey

         n := ASCAN( aHotKeys,                                         ;
                     { |c| UPPER( c) ==  UPPER( CHR( nKey ) ) }                        )
         If n > 0
             nChoice := n
             KEYBOARD CHR( K_ENTER )
         Endif

    ENDCASE

    // Si cambi a otro botn
    If ! nOldChoice == nChoice
       DrawButtons( oGet:Row, oGet:Col, aButtons, nChoice, lHorizontal, nGap, ;
                          cColStd, cColEnh,;
                          cColStdHotKey, cColEnhHotKey,cColShad ,;
                          .T. )
    Endif

Enddo


oGet:VarPut( nChoice )
Dispbegin()
cSavedScreen := savescreen( oGet:row, oGet:col, oGet:row, oGet:col )
oGet:KillFocus()
restscreen( oGet:row, oGet:col, oGet:row, oGet:col, cSavedScreen )
Dispend()

If nKey == K_ENTER .or. nKey == K_SPACE
   DrawButtons( oGet:Row, oGet:Col, aButtons, nChoice, lHorizontal, nGap, ;
                      cColStd, cColEnh,;
                      cColStdHotKey, cColEnhHotKey, cColShad ,;
                     .T. , .T. )

Else
   DrawButtons( oGet:Row, oGet:Col, aButtons, nChoice, lHorizontal, nGap, ;
                      cColStd, cColEnh,;
                      cColStdHotKey, cColEnhHotKey, cColShad )

Endif

SETCURSOR( nCurs )

Return NIL

