
#include "inkey.ch"
#include "setcurs.ch"
#include "getexit.ch"


// Stack para botones
Static  aAllRadButtons := {}


/*
  FUNCTION RADBUTNEW()
  ---------------------
  Waldo Gomez Alvarez
*/

Function RadButNew( oGet,           ; // Objeto Get
                  nChoice,          ; // Valor a retornar
                  aRadButtons,      ; // Arreglo de Radiobuttons usuario
                  nGap,             ; // Separacin entre Radiobotones.
                  lHorizontal       ) // Opcin Radiobuttons horizontales

Local cColor, nRow , nCol

nRow = oGet:Row
nCol = oGet:Col

// Maneja defectos
lHorizontal  := If( Valtype(lHorizontal) == "L", lHorizontal, .F. )
nGap         := If( Valtype(nGap) == "N" , nGap , 1 )
nGap         := If( nGap > 0 , nGap  , 1 )

cColor       := oGet:ColorSpec

// Agrego al arreglo de Radiobuttons
aAdd( aAllRadButtons, { oGet:Name, aRadButtons, lHorizontal , nGap } )

// Dibuja los Radiobuttons.
DrawRadButtons( nRow, nCol, aRadButtons, nChoice, nChoice, cColor, lHorizontal, nGap )

Return NIL


/*
   FUNCTION DRAWRADBUTONS()
   ------------------------
*/

Function DrawRadButtons( nRow, nCol, aRadButtons,;
                         nPosCursor, nSelected, cColor, lHorizontal, nGap )

Local i
Local nBtnOffset   := 0
Local nTotRadButtons
Local nOffSet := 0

nTotRadButtons := Len( aRadButtons )

For i = 1 to nTotRadButtons

    DispRadBtn( nRow, nCol, nBtnOffset, aRadButtons[i],;
                If( nSelected == i , .T. , .F. ),  cColor, lHorizontal  )

    If nPosCursor == i
       nOffSet := nBtnOffSet
    Endif

    If lHorizontal
       nBtnOffset += ( Len( aRadButtons[i] ) + 4 + nGap )
    Else
       nBtnOffset += nGap
    Endif

Next

If lHorizontal
   nCol := nCol + nOffSet
Else
   nRow := nRow + nOffSet
EndIf

SetPos( nRow, nCol + 1 )

Return NIL


/*
   FUNCTION DISPRADBTN
   -------------------
*/

Function  DispRadBtn( nRow, nCol, nBtnOffset, cLabel,;
                          nEstado, cColor, lHorizontal  )


If lHorizontal
   nCol := nCol + nBtnOffSet
Else
   nRow := nRow + nBtnOffSet
EndIf


If nEstado
   @ nRow, nCol Say "(*) " + cLabel  COLOR cColor
Else
   @ nRow, nCol Say "( ) " + cLabel  COLOR cColor
Endif

Return Nil



/*
  FUNCTION RADBUTREADER
  ----------------------
  Controlador de los Radiobotones
*/

Function RadButReader( oGet )

Local nCurs := SETCURSOR(0)
Local lHorizontal
Local cColor
Local aRadButtons , nSelected , nMaxChoices
LOCAL nKey
Local nPosCursor
Local nGap

aRadButtons   := aAllRadButtons[ Ascan(aAllRadButtons, { |a| a[1] == oGet:Name }),2]
lHorizontal   := aAllRadButtons[ Ascan(aAllRadButtons, { |a| a[1] == oGet:Name }),3]
nGap          := aAllRadButtons[ Ascan(aAllRadButtons, { |a| a[1] == oGet:Name }),4]

cColor        := oGet:ColorSpec

nSelected     := oGet:VarGet()
nPosCursor    := nSelected

nMaxChoices   := Len( aRadButtons )

// Aqu se pone el Get
Dispbegin()
cSavedScreen := savescreen( oGet:row, oGet:col, oGet:row, oGet:col )
oGet:SetFocus()
restscreen( oGet:row, oGet:col, oGet:row, oGet:col, cSavedScreen )
DispEnd()

DrawRadButtons( oGet:Row, oGet:Col, aRadButtons, nPosCursor, nSelected, cColor, lHorizontal, nGap )

oGet:exitState := GE_NOEXIT

Do WHILE ( oGet:exitState == GE_NOEXIT )

    SetCursor(1)
    nKey := Inkey(0)
    SetCursor(0)

    DO CASE
    CASE nKey == K_ESC
         oGet:ExitState := GE_ESCAPE

    CASE nKey == K_ENTER  .or. nKey == K_SPACE
         nSelected := nPosCursor
         oGet:VarPut( nSelected )

    CASE nKey == K_LEFT .or. nKey == K_UP
         If nPosCursor == 1
            oGet:ExitState := GE_UP
         Else
            nPosCursor--
         Endif

    CASE nKey == K_RIGHT .or. nKey == K_DOWN
         If nPosCursor == nMaxChoices
            oGet:ExitState := GE_DOWN
         Else
            nPosCursor++
         Endif


*   CASE nKey == K_LEFT
*        If lHorizontal
*            nPosCursor := If(nPosCursor==1,nMaxChoices,nPosCursor-1)
*        Else
*            oGet:ExitState := GE_UP
*        Endif

*   CASE nKey == K_UP
*        If lHorizontal
*            oGet:ExitState := GE_UP
*        Else
*            nPosCursor := If(nPosCursor==1,nMaxChoices,nPosCursor-1)
*        Endif


*   CASE nKey == K_RIGHT
*        If lHorizontal
*            nPosCursor := If(nPosCursor==nMaxChoices,1,nPosCursor+1)
*        Else
*            oGet:ExitState := GE_DOWN
*        Endif
*
*
*   CASE nKey == K_DOWN
*        If lHorizontal
*            oGet:ExitState := GE_DOWN
*        Else
*            nPosCursor := If(nPosCursor==nMaxChoices,1, nPosCursor+1)
*        Endif

    CASE nKey == K_TAB
        oGet:ExitState := GE_DOWN

    CASE nKey == K_SH_TAB
        oGet:ExitState := GE_UP

    ENDCASE

    DrawRadButtons( oGet:Row, oGet:Col, aRadButtons, nPosCursor, nSelected, cColor, lHorizontal, nGap )

Enddo


Dispbegin()
cSavedScreen := savescreen( oGet:row, oGet:col, oGet:row, oGet:col )
oGet:KillFocus()
restscreen( oGet:row, oGet:col, oGet:row, oGet:col, cSavedScreen )
Dispend()

SetCursor( nCurs )

Return NIL


